import assert from 'assert';
import elGamal from '../src/elGamal.js';
import ElGamalKey from '../src/elGamalKey.js';

const key = 24;
const msg = "Hi, it's me, Mario";
const [prv, pub] = ElGamalKey.generate(key);
const cypherText = elGamal.encrypt(msg, pub);

const number = 5;
const threshold = 3;
const sharedKeys = prv.share(number, threshold).slice(-threshold)
const joinedKey = ElGamalKey.combine(sharedKeys)
assert.equal(prv.toString(), joinedKey.toString())

const partialCypher = sharedKeys.map(sh => elGamal.decryptPartial(cypherText, sh));
var joinedMsg = elGamal.combinePartial(partialCypher, pub);
assert.equal(msg, joinedMsg)
